#ifndef CYGONCE_HAL_PLATFORM_SETUP_H
#define CYGONCE_HAL_PLATFORM_SETUP_H

/*=============================================================================
//
//      hal_platform_setup.h
//
//      Platform specific support for HAL (assembly code)
//
//=============================================================================
//####COPYRIGHTBEGIN####
//
// -------------------------------------------
// The contents of this file are subject to the Cygnus eCos Public License
// Version 1.0 (the "License"); you may not use this file except in
// compliance with the License.  You may obtain a copy of the License at
// http://sourceware.cygnus.com/ecos
// 
// Software distributed under the License is distributed on anS "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the
// License for the specific language governing rights and limitations under
// the License.
// 
// The Original Code is eCos - Embedded Cygnus Operating System, released
// September 30, 1998.
// 
// The Initial Developer of the Original Code is Cygnus.  Portions created
// by Cygnus are Copyright (C) 1998,1999 Cygnus Solutions.  All Rights Reserved.
// -------------------------------------------
//
//####COPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    gthomas
// Contributors: gthomas
// Date:        1999-04-13
// Purpose:     ARM/EBSA-285 platform specific support routines
// Description: 
// Usage:       #include <cyg/hal/hal_platform_setup.h>
//
//####DESCRIPTIONEND####
//
//===========================================================================*/

#if CYGNUM_HAL_COMMON_INTERRUPTS_STACK_SIZE==4096
// Override default to a more sensible value
#undef  CYGNUM_HAL_COMMON_INTERRUPTS_STACK_SIZE
#define CYGNUM_HAL_COMMON_INTERRUPTS_STACK_SIZE 2048
#endif

/* hsy: for ebsa-285 */
#if defined(CYG_HAL_STARTUP_ROM) || defined(CYG_HAL_STARTUP_STUBS)
#define PLATFORM_SETUP1                         \
    mrs r1, cpsr                                ;\
    bic r1, r1, #0x0000003F /* #MASK_MODE */    ;\
    orr r1, r1, #0xD3                           ;\
    msr cpsr, r1                                ;\
    mcr 15, 0, r14, c15, c1, 2                  ;\
    mov r1, #0x270                              ;\
    mcr 15, 0, r1, c1, c0, 0                    ;\
    mcr 15, 0, r1, c7, c10, 4                   ;\
    mcr 15, 0, r1, c7, c6, 0                    ;\
    mcr 15, 0, r1, c7, c5, 0                    ;\
    ldr pc, =__HiReset                          ;\
__HiReset:                                      ;\
    str r0, [r0, -r0]                           ;\
    bl init_x_bus /* Initialize X-BUS for Serial and LED */ ;\
    ldr r3, =0                                  ;\
    ldr r4, =0x04 /* RED_LED */                 ;\
    bl set_leds                                 ;\
    bl init_ram  /* Initialize RAM */
#else
#define PLATFORM_SETUP1                         \
    ldr pc, =__HiReset                          ;\
__HiReset:
    str r0, [r0, -r0]   
#endif


/*---------------------------------------------------------------------------*/
/* end of hal_platform_setup.h                                               */
#endif /* CYGONCE_HAL_PLATFORM_SETUP_H */
