//==========================================================================
//
//      ebsa285_misc.c
//
//      HAL misc board support code for ARM EBSA-285
//
//==========================================================================
//####COPYRIGHTBEGIN####
//
// -------------------------------------------
// The contents of this file are subject to the Cygnus eCos Public License
// Version 1.0 (the "License"); you may not use this file except in
// compliance with the License.  You may obtain a copy of the License at
// http://sourceware.cygnus.com/ecos
// 
// Software distributed under the License is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the
// License for the specific language governing rights and limitations under
// the License.
// 
// The Original Code is eCos - Embedded Cygnus Operating System, released
// September 30, 1998.
// 
// The Initial Developer of the Original Code is Cygnus.  Portions created
// by Cygnus are Copyright (C) 1998,1999 Cygnus Solutions.  All Rights Reserved.
// -------------------------------------------
//
//####COPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    hwang sungyeon
// Contributors: hwang sungyeon
// Date:         1999-10-02
// Purpose:      HAL board support
// Description:  Implementations of HAL board interfaces
//
//####DESCRIPTIONEND####
//
//========================================================================*/

#include <pkgconf/hal.h>

#include <cyg/infra/cyg_type.h>         // base types
#include <cyg/infra/cyg_trac.h>         // tracing macros
#include <cyg/infra/cyg_ass.h>          // assertion macros

#include <cyg/hal/hal_io.h>             // IO macros
#include <cyg/hal/hal_arch.h>           // Register state info
#include <cyg/hal/hal_diag.h>
#include <cyg/hal/hal_intr.h>           // necessary?
#include <cyg/hal/hal_cache.h>
#ifdef CYGDBG_HAL_DEBUG_GDB_BREAK_SUPPORT
#include <cyg/hal/drv_api.h>            // HAL ISR support
#endif

#include "ebsa285.h"

/*------------------------------------------------------------------------*/
// On-board timer
/*------------------------------------------------------------------------*/

// Timer registers
// Interrupt controller registers
// Clock control registers

#undef _TIMERS_TESTING
#ifdef _TIMERS_TESTING
static void ebsa285_setup_timer1(cyg_uint32 period);
#endif

static cyg_uint32 _period;

#ifdef CYGDBG_HAL_DEBUG_GDB_BREAK_SUPPORT
static cyg_interrupt abort_interrupt;
static cyg_handle_t  abort_interrupt_handle;

// This ISR is called only for the Abort button interrupt
static int
ebsa285_abort_isr(cyg_vector_t vector, cyg_addrword_t data, HAL_SavedRegisters *regs)
{
 
}
#endif

void hal_clock_initialize(cyg_uint32 period)
{
#ifdef CYGDBG_HAL_DEBUG_GDB_BREAK_SUPPORT

#endif
#ifdef _TIMERS_TESTING

#endif
}

void hal_clock_reset(cyg_uint32 vector, cyg_uint32 period)
{
}

void hal_clock_read(cyg_uint32 *pvalue)
{

}


void hal_hardware_init(void)
{
  // hsy 99/10/13
  // NOP!!
}


// This routine is called to respond to a hardware interrupt (IRQ).  It
// should interrogate the hardware and return the IRQ vector number.

int hal_IRQ_handler(void)
{

}


//
// Interrupt control
//

void hal_interrupt_mask(int vector)
{

}

void hal_interrupt_unmask(int vector)
{
 
}

void hal_interrupt_acknowledge(int vector)
{
}

void hal_interrupt_configure(int vector, int level, int up)
{

}

void hal_interrupt_set_level(int vector, int level)
{

}

void hal_show_IRQ(int vector, int data, int handler)
{
}

#ifdef _TIMERS_TESTING
#include <cyg/hal/drv_api.h>            // HAL ISR support
static cyg_interrupt timer1_interrupt;
static cyg_handle_t  timer1_interrupt_handle;
static cyg_uint32    timer1_count;

// This ISR is called only for the high speed timer under test
static int
ebas285_timer1_isr(cyg_vector_t vector, cyg_addrword_t data, HAL_SavedRegisters *regs)
{

}

static void
ebsa285_setup_timer1(cyg_uint32 period)
{
}
#endif


//---------------------------------------------------------------------
// SetLED
void SetLED
	 (
	int and, /*  LED bit s */
	int eor   /*  LED bits */
	)
{
	unsigned char current = 0;
	volatile unsigned char *p = (volatile unsigned char *) LED_BANK;

	current = ((current & and) ^ eor) & 0x7;
	*p = (current ^ 0x7);
}


/*------------------------------------------------------------------------*/
// EOF hal_misc.c
